/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Dialect Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: HLFIROpBase.td                                                       *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace hlfir {

/// High Level Fortran IR.
/// This dialect models Fortran expressions and assignments without requiring
///     the allocation and manipulation of temporary storage.
///     It allows running high level optimization passes and is rather
///     straightforward to generate from Fortran expressions and assignments.
/// 
///     It is not a complete implementation of Fortran, for constructs and lower
///     level operations, FIR should be used directly.
/// 
///     A bufferization pass transforms hlfir.expr values into FIR temporary in
///     memory, and its translation pass to FIR translates high level operations
///     into sequence of lower level FIR operations operating on memory.
class hlfirDialect : public ::mlir::Dialect {
  explicit hlfirDialect(::mlir::MLIRContext *context);

  void initialize();
  friend class ::mlir::MLIRContext;
public:
  ~hlfirDialect() override;
  static constexpr ::llvm::StringLiteral getDialectNamespace() {
    return ::llvm::StringLiteral("hlfir");
  }

  /// Parse a type registered to this dialect.
  ::mlir::Type parseType(::mlir::DialectAsmParser &parser) const override;

  /// Print a type registered to this dialect.
  void printType(::mlir::Type type,
                 ::mlir::DialectAsmPrinter &os) const override;
};
} // namespace hlfir
MLIR_DECLARE_EXPLICIT_TYPE_ID(hlfir::hlfirDialect)
